//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using Tecan.Sila2;


namespace Tecan.Sila2.Recovery
{
    
    
    /// <summary>
    /// Data transfer object for the request of the Execute Continuation Option command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class ExecuteContinuationOptionRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        private Tecan.Sila2.StringDto _commandExecutionUUID;
        
        private Tecan.Sila2.StringDto _continuationOption;
        
        private Tecan.Sila2.DynamicClient.AnyTypeDto _inputData;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public ExecuteContinuationOptionRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="commandExecutionUUID">The UUID of the observable command execution for which the error shall be handled.</param>
        /// <param name="continuationOption">
        ///        The identifier of the continuation option to be executed. It must match the identifier of one of the continuation options
        ///        specified in the 'ContinuationOptions' list of the according 'RecoverableError' object.
        ///      </param>
        /// <param name="inputData">
        ///        If required this parameter contains the data that has to be sent along with a continuation option in order to execute the requested
        ///        recovery option. The kind of the data as well as the required format must be described in the 'RequiredInputData' field of the
        ///        respective continuation option.
        ///      </param>
        public ExecuteContinuationOptionRequestDto(string commandExecutionUUID, string continuationOption, Tecan.Sila2.DynamicClient.DynamicObjectProperty inputData, Tecan.Sila2.IBinaryStore store)
        {
            CommandExecutionUUID = new Tecan.Sila2.StringDto(commandExecutionUUID, store);
            ContinuationOption = new Tecan.Sila2.StringDto(continuationOption, store);
            InputData = new Tecan.Sila2.DynamicClient.AnyTypeDto(inputData, store);
        }
        
        /// <summary>
        /// The UUID of the observable command execution for which the error shall be handled.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.StringDto CommandExecutionUUID
        {
            get
            {
                return _commandExecutionUUID;
            }
            set
            {
                _commandExecutionUUID = value;
            }
        }
        
        /// <summary>
        /// The identifier of the continuation option to be executed. It must match the identifier of one of the continuation options
        /// specified in the 'ContinuationOptions' list of the according 'RecoverableError' object.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(2)]
        public Tecan.Sila2.StringDto ContinuationOption
        {
            get
            {
                return _continuationOption;
            }
            set
            {
                _continuationOption = value;
            }
        }
        
        /// <summary>
        /// If required this parameter contains the data that has to be sent along with a continuation option in order to execute the requested
        /// recovery option. The kind of the data as well as the required format must be described in the 'RequiredInputData' field of the
        /// respective continuation option.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(3)]
        public Tecan.Sila2.DynamicClient.AnyTypeDto InputData
        {
            get
            {
                return _inputData;
            }
            set
            {
                _inputData = value;
            }
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "org.silastandard/core/ErrorRecoveryService/v1/Command/ExecuteContinuationOption";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(CommandExecutionUUID, "commandExecutionUUID");
            if ((CommandExecutionUUID.Value.Length != 36))
            {
                throw new ArgumentException(string.Format("CommandExecutionUUID has length {0} but should have been 36", CommandExecutionUUID.Value.Length), "commandExecutionUUID");
            }
            if ((RegexConstraint.IsMatch(CommandExecutionUUID.Value, "[0-9a-f]{8}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{12}") == false))
            {
                throw new ArgumentException(string.Format("CommandExecutionUUID \'{0}\' does not match pattern \'[0-9a-f]{8}\\-[0-9a-f]{4}\\-[0-9" +
                            "a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{12}\'", CommandExecutionUUID.Value), "commandExecutionUUID");
            }
            Argument.Validate(ContinuationOption, "continuationOption");
            Argument.Validate(InputData, "inputData");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            string errors = ((("" + Argument.Require(CommandExecutionUUID, "commandExecutionUUID")) 
                        + Argument.Require(ContinuationOption, "continuationOption")) 
                        + Argument.Require(InputData, "inputData"));
            if ((CommandExecutionUUID.Value.Length != 36))
            {
                errors = (errors + string.Format("CommandExecutionUUID has length {0} but should have been 36", CommandExecutionUUID.Value.Length));
            }
            if ((RegexConstraint.IsMatch(CommandExecutionUUID.Value, "[0-9a-f]{8}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{12}") == false))
            {
                errors = (errors + string.Format("CommandExecutionUUID \'{0}\' does not match pattern \'[0-9a-f]{8}\\-[0-9a-f]{4}\\-[0-9" +
                        "a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{12}\'", CommandExecutionUUID.Value));
            }
            return errors;
        }
    }
    
    /// <summary>
    /// Data transfer object for the request of the Abort Error Handling command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class AbortErrorHandlingRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        private Tecan.Sila2.StringDto _commandExecutionUUID;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public AbortErrorHandlingRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="commandExecutionUUID">The UUID of the observable command execution for which the error handling shall be aborted.</param>
        public AbortErrorHandlingRequestDto(string commandExecutionUUID, Tecan.Sila2.IBinaryStore store)
        {
            CommandExecutionUUID = new Tecan.Sila2.StringDto(commandExecutionUUID, store);
        }
        
        /// <summary>
        /// The UUID of the observable command execution for which the error handling shall be aborted.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.StringDto CommandExecutionUUID
        {
            get
            {
                return _commandExecutionUUID;
            }
            set
            {
                _commandExecutionUUID = value;
            }
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "org.silastandard/core/ErrorRecoveryService/v1/Command/AbortErrorHandling";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(CommandExecutionUUID, "commandExecutionUUID");
            if ((CommandExecutionUUID.Value.Length != 36))
            {
                throw new ArgumentException(string.Format("CommandExecutionUUID has length {0} but should have been 36", CommandExecutionUUID.Value.Length), "commandExecutionUUID");
            }
            if ((RegexConstraint.IsMatch(CommandExecutionUUID.Value, "[0-9a-f]{8}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{12}") == false))
            {
                throw new ArgumentException(string.Format("CommandExecutionUUID \'{0}\' does not match pattern \'[0-9a-f]{8}\\-[0-9a-f]{4}\\-[0-9" +
                            "a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{12}\'", CommandExecutionUUID.Value), "commandExecutionUUID");
            }
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            string errors = ("" + Argument.Require(CommandExecutionUUID, "commandExecutionUUID"));
            if ((CommandExecutionUUID.Value.Length != 36))
            {
                errors = (errors + string.Format("CommandExecutionUUID has length {0} but should have been 36", CommandExecutionUUID.Value.Length));
            }
            if ((RegexConstraint.IsMatch(CommandExecutionUUID.Value, "[0-9a-f]{8}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{12}") == false))
            {
                errors = (errors + string.Format("CommandExecutionUUID \'{0}\' does not match pattern \'[0-9a-f]{8}\\-[0-9a-f]{4}\\-[0-9" +
                        "a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{12}\'", CommandExecutionUUID.Value));
            }
            return errors;
        }
    }
    
    /// <summary>
    /// Data transfer object for the request of the Set Error Handling Timeout command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class SetErrorHandlingTimeoutRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        private TimeoutDto _errorHandlingTimeout;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public SetErrorHandlingTimeoutRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="errorHandlingTimeout">The timeout in seconds.</param>
        public SetErrorHandlingTimeoutRequestDto(Timeout errorHandlingTimeout, Tecan.Sila2.IBinaryStore store)
        {
            ErrorHandlingTimeout = new TimeoutDto(errorHandlingTimeout, store);
        }
        
        /// <summary>
        /// The timeout in seconds.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public TimeoutDto ErrorHandlingTimeout
        {
            get
            {
                return _errorHandlingTimeout;
            }
            set
            {
                _errorHandlingTimeout = value;
            }
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "org.silastandard/core/ErrorRecoveryService/v1/Command/SetErrorHandlingTimeout";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(ErrorHandlingTimeout, "errorHandlingTimeout");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(ErrorHandlingTimeout, "errorHandlingTimeout"));
        }
    }
    
    /// <summary>
    /// The data transfer object for Recoverable Error
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class RecoverableErrorDto : Tecan.Sila2.ISilaTransferObject<RecoverableError>
    {
        
        private InnerStruct _inner;
        
        /// <summary>
        /// Initializes a new instance (to be used by the serializer)
        /// </summary>
        public RecoverableErrorDto()
        {
            _inner = new InnerStruct();
        }
        
        /// <summary>
        /// Initializes a new data transfer object from the business object
        /// </summary>
        /// <param name="inner">The business object that should be transferred</param>
        /// <param name="store">A component to handle binary data</param>
        public RecoverableErrorDto(RecoverableError inner, Tecan.Sila2.IBinaryStore store)
        {
            _inner = new InnerStruct(inner, store);
        }
        
        /// <summary>
        /// The fully qualified identifier of the command whose execution produced the error.
        /// </summary>
        public Tecan.Sila2.StringDto CommandIdentifier_
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.CommandIdentifier_;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.CommandIdentifier_ = value;
            }
        }
        
        /// <summary>
        /// The UUID of the observable command execution during which the error occurred.
        /// </summary>
        public Tecan.Sila2.StringDto CommandExecutionUUID
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.CommandExecutionUUID;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.CommandExecutionUUID = value;
            }
        }
        
        /// <summary>
        /// This message describes the error situation. It should contain the reason of the error and additional error handling
        /// explanation.
        /// </summary>
        public Tecan.Sila2.StringDto ErrorMessage
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.ErrorMessage;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.ErrorMessage = value;
            }
        }
        
        /// <summary>
        /// A list of possible options to recover the error and continue the command execution.
        /// </summary>
        public System.Collections.Generic.List<ContinuationOptionDto> ContinuationOptions
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.ContinuationOptions;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.ContinuationOptions = value;
            }
        }
        
        /// <summary>
        /// The identifier of a continuation option that is marked as the preferred option. It must be an identifier of one of the
        /// continuation options of the 'ContinuationOptions' list.
        /// It can also be defined to be automatically executed after a timeout specified by the 'AutomaticExecutionTimeout' element.
        /// </summary>
        public Tecan.Sila2.StringDto DefaultOption
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.DefaultOption;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.DefaultOption = value;
            }
        }
        
        /// <summary>
        /// Specifies a timeout for handling the error by the client. If the client does not send a continuation option
        /// within the specified duration, the defined default option will automatically be executed.
        /// A value of 0 means, that no automatic execution will be done by the server.
        /// This timeout only takes effect if a default option is specified, otherwise it will be ignored.
        /// </summary>
        public TimeoutDto AutomaticExecutionTimeout
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.AutomaticExecutionTimeout;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.AutomaticExecutionTimeout = value;
            }
        }
        
        /// <summary>
        /// The actual contents of the data transfer object.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public InnerStruct Inner
        {
            get
            {
                return _inner;
            }
            set
            {
                _inner = value;
            }
        }
        
        /// <summary>
        /// Extracts the transferred value
        /// </summary>
        /// <param name="store">The binary store in which to store binary data</param>
        /// <returns>the inner value</returns>
        public RecoverableError Extract(Tecan.Sila2.IBinaryStore store)
        {
            return new RecoverableError(CommandIdentifier_.Extract(store), CommandExecutionUUID.Extract(store), ErrorMessage.Extract(store), ContinuationOptions.Extract(store), DefaultOption.Extract(store), AutomaticExecutionTimeout.Extract(store));
        }
        
        /// <summary>
        /// Creates the data transfer object from the given object to transport
        /// </summary>
        /// <param name="inner">The object to transfer</param>
        /// <param name="store">An object to store binary data</param>
        public static RecoverableErrorDto Create(RecoverableError inner, Tecan.Sila2.IBinaryStore store)
        {
            return new RecoverableErrorDto(inner, store);
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            string errors = (((((("" + Argument.Require(CommandIdentifier_, "commandIdentifier")) 
                        + Argument.Require(CommandExecutionUUID, "commandExecutionUUID")) 
                        + Argument.Require(ErrorMessage, "errorMessage")) 
                        + Argument.Require(ContinuationOptions, "continuationOptions")) 
                        + Argument.Require(DefaultOption, "defaultOption")) 
                        + Argument.Require(AutomaticExecutionTimeout, "automaticExecutionTimeout"));
            if ((IdentifierConstraint.IsValid(CommandIdentifier_.Value, Tecan.Sila2.IdentifierType.CommandIdentifier) == false))
            {
                errors = (errors + string.Format("CommandIdentifier_ \'{0}\' is not a valid CommandIdentifier", CommandIdentifier_.Value));
            }
            if ((CommandExecutionUUID.Value.Length != 36))
            {
                errors = (errors + string.Format("CommandExecutionUUID has length {0} but should have been 36", CommandExecutionUUID.Value.Length));
            }
            if ((RegexConstraint.IsMatch(CommandExecutionUUID.Value, "[0-9a-f]{8}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{12}") == false))
            {
                errors = (errors + string.Format("CommandExecutionUUID \'{0}\' does not match pattern \'[0-9a-f]{8}\\-[0-9a-f]{4}\\-[0-9" +
                        "a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{12}\'", CommandExecutionUUID.Value));
            }
            return errors;
        }
        
        /// <summary>
        /// Represents the inner structure for actual content
        /// </summary>
        [ProtoBuf.ProtoContractAttribute()]
        public class InnerStruct
        {
            
            private Tecan.Sila2.StringDto _commandIdentifier_;
            
            private Tecan.Sila2.StringDto _commandExecutionUUID;
            
            private Tecan.Sila2.StringDto _errorMessage;
            
            private System.Collections.Generic.List<ContinuationOptionDto> _continuationOptions;
            
            private Tecan.Sila2.StringDto _defaultOption;
            
            private TimeoutDto _automaticExecutionTimeout;
            
            /// <summary>
            /// Initializes a new instance (to be used by the serializer)
            /// </summary>
            public InnerStruct()
            {
            }
            
            /// <summary>
            /// Initializes a new data transfer object from the business object
            /// </summary>
            /// <param name="inner">The business object that should be transferred</param>
            /// <param name="store">A component to handle binary data</param>
            public InnerStruct(RecoverableError inner, Tecan.Sila2.IBinaryStore store)
            {
                CommandIdentifier_ = new Tecan.Sila2.StringDto(inner.CommandIdentifier, store);
                CommandExecutionUUID = new Tecan.Sila2.StringDto(inner.CommandExecutionUUID, store);
                ErrorMessage = new Tecan.Sila2.StringDto(inner.ErrorMessage, store);
                ContinuationOptions = Tecan.Sila2.DtoExtensions.Encapsulate(inner.ContinuationOptions, ContinuationOptionDto.Create, store);
                DefaultOption = new Tecan.Sila2.StringDto(inner.DefaultOption, store);
                AutomaticExecutionTimeout = new TimeoutDto(inner.AutomaticExecutionTimeout, store);
            }
            
            /// <summary>
            /// The fully qualified identifier of the command whose execution produced the error.
            /// </summary>
            [ProtoBuf.ProtoMemberAttribute(1)]
            public Tecan.Sila2.StringDto CommandIdentifier_
            {
                get
                {
                    return _commandIdentifier_;
                }
                set
                {
                    _commandIdentifier_ = value;
                }
            }
            
            /// <summary>
            /// The UUID of the observable command execution during which the error occurred.
            /// </summary>
            [ProtoBuf.ProtoMemberAttribute(2)]
            public Tecan.Sila2.StringDto CommandExecutionUUID
            {
                get
                {
                    return _commandExecutionUUID;
                }
                set
                {
                    _commandExecutionUUID = value;
                }
            }
            
            /// <summary>
            /// This message describes the error situation. It should contain the reason of the error and additional error handling
            /// explanation.
            /// </summary>
            [ProtoBuf.ProtoMemberAttribute(3)]
            public Tecan.Sila2.StringDto ErrorMessage
            {
                get
                {
                    return _errorMessage;
                }
                set
                {
                    _errorMessage = value;
                }
            }
            
            /// <summary>
            /// A list of possible options to recover the error and continue the command execution.
            /// </summary>
            [ProtoBuf.ProtoMemberAttribute(4)]
            public System.Collections.Generic.List<ContinuationOptionDto> ContinuationOptions
            {
                get
                {
                    return _continuationOptions;
                }
                set
                {
                    _continuationOptions = value;
                }
            }
            
            /// <summary>
            /// The identifier of a continuation option that is marked as the preferred option. It must be an identifier of one of the
            /// continuation options of the 'ContinuationOptions' list.
            /// It can also be defined to be automatically executed after a timeout specified by the 'AutomaticExecutionTimeout' element.
            /// </summary>
            [ProtoBuf.ProtoMemberAttribute(5)]
            public Tecan.Sila2.StringDto DefaultOption
            {
                get
                {
                    return _defaultOption;
                }
                set
                {
                    _defaultOption = value;
                }
            }
            
            /// <summary>
            /// Specifies a timeout for handling the error by the client. If the client does not send a continuation option
            /// within the specified duration, the defined default option will automatically be executed.
            /// A value of 0 means, that no automatic execution will be done by the server.
            /// This timeout only takes effect if a default option is specified, otherwise it will be ignored.
            /// </summary>
            [ProtoBuf.ProtoMemberAttribute(6)]
            public TimeoutDto AutomaticExecutionTimeout
            {
                get
                {
                    return _automaticExecutionTimeout;
                }
                set
                {
                    _automaticExecutionTimeout = value;
                }
            }
        }
    }
    
    /// <summary>
    /// The data transfer object for Continuation Option
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class ContinuationOptionDto : Tecan.Sila2.ISilaTransferObject<ContinuationOption>
    {
        
        private InnerStruct _inner;
        
        /// <summary>
        /// Initializes a new instance (to be used by the serializer)
        /// </summary>
        public ContinuationOptionDto()
        {
            _inner = new InnerStruct();
        }
        
        /// <summary>
        /// Initializes a new data transfer object from the business object
        /// </summary>
        /// <param name="inner">The business object that should be transferred</param>
        /// <param name="store">A component to handle binary data</param>
        public ContinuationOptionDto(ContinuationOption inner, Tecan.Sila2.IBinaryStore store)
        {
            _inner = new InnerStruct(inner, store);
        }
        
        /// <summary>
        /// The identifier of the continuation option. It must be unique within the RecoverableError object.
        /// </summary>
        public Tecan.Sila2.StringDto Identifier
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.Identifier;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.Identifier = value;
            }
        }
        
        /// <summary>
        /// A human readable text describing the continuation option. It must explain all required manual actions by the operator
        /// as well as the actions that will be executed by the server and the expectable results when this option is selected.
        /// If there is additional data that can be sent along with the continuation option, the kind of the data as well as the
        /// required format must be described as well.
        /// </summary>
        public Tecan.Sila2.StringDto Description
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.Description;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.Description = value;
            }
        }
        
        /// <summary>
        /// This field defines the structure of the additional input data that is required in order to execute this continuation
        /// option. The format is a SiLA data type definition according to the schema DataTypes.xsd. If this field is empty no
        /// additional data is required.
        /// </summary>
        public Tecan.Sila2.StringDto RequiredInputData
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.RequiredInputData;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.RequiredInputData = value;
            }
        }
        
        /// <summary>
        /// The actual contents of the data transfer object.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public InnerStruct Inner
        {
            get
            {
                return _inner;
            }
            set
            {
                _inner = value;
            }
        }
        
        /// <summary>
        /// Extracts the transferred value
        /// </summary>
        /// <param name="store">The binary store in which to store binary data</param>
        /// <returns>the inner value</returns>
        public ContinuationOption Extract(Tecan.Sila2.IBinaryStore store)
        {
            return new ContinuationOption(Identifier.Extract(store), Description.Extract(store), RequiredInputData.Extract(store));
        }
        
        /// <summary>
        /// Creates the data transfer object from the given object to transport
        /// </summary>
        /// <param name="inner">The object to transfer</param>
        /// <param name="store">An object to store binary data</param>
        public static ContinuationOptionDto Create(ContinuationOption inner, Tecan.Sila2.IBinaryStore store)
        {
            return new ContinuationOptionDto(inner, store);
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ((("" + Argument.Require(Identifier, "identifier")) 
                        + Argument.Require(Description, "description")) 
                        + Argument.Require(RequiredInputData, "requiredInputData"));
        }
        
        /// <summary>
        /// Represents the inner structure for actual content
        /// </summary>
        [ProtoBuf.ProtoContractAttribute()]
        public class InnerStruct
        {
            
            private Tecan.Sila2.StringDto _identifier;
            
            private Tecan.Sila2.StringDto _description;
            
            private Tecan.Sila2.StringDto _requiredInputData;
            
            /// <summary>
            /// Initializes a new instance (to be used by the serializer)
            /// </summary>
            public InnerStruct()
            {
            }
            
            /// <summary>
            /// Initializes a new data transfer object from the business object
            /// </summary>
            /// <param name="inner">The business object that should be transferred</param>
            /// <param name="store">A component to handle binary data</param>
            public InnerStruct(ContinuationOption inner, Tecan.Sila2.IBinaryStore store)
            {
                Identifier = new Tecan.Sila2.StringDto(inner.Identifier, store);
                Description = new Tecan.Sila2.StringDto(inner.Description, store);
                RequiredInputData = new Tecan.Sila2.StringDto(inner.RequiredInputData, store);
            }
            
            /// <summary>
            /// The identifier of the continuation option. It must be unique within the RecoverableError object.
            /// </summary>
            [ProtoBuf.ProtoMemberAttribute(1)]
            public Tecan.Sila2.StringDto Identifier
            {
                get
                {
                    return _identifier;
                }
                set
                {
                    _identifier = value;
                }
            }
            
            /// <summary>
            /// A human readable text describing the continuation option. It must explain all required manual actions by the operator
            /// as well as the actions that will be executed by the server and the expectable results when this option is selected.
            /// If there is additional data that can be sent along with the continuation option, the kind of the data as well as the
            /// required format must be described as well.
            /// </summary>
            [ProtoBuf.ProtoMemberAttribute(2)]
            public Tecan.Sila2.StringDto Description
            {
                get
                {
                    return _description;
                }
                set
                {
                    _description = value;
                }
            }
            
            /// <summary>
            /// This field defines the structure of the additional input data that is required in order to execute this continuation
            /// option. The format is a SiLA data type definition according to the schema DataTypes.xsd. If this field is empty no
            /// additional data is required.
            /// </summary>
            [ProtoBuf.ProtoMemberAttribute(3)]
            public Tecan.Sila2.StringDto RequiredInputData
            {
                get
                {
                    return _requiredInputData;
                }
                set
                {
                    _requiredInputData = value;
                }
            }
        }
    }
    
    /// <summary>
    /// The data transfer object for Timeout
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class TimeoutDto : Tecan.Sila2.ISilaTransferObject<Timeout>
    {
        
        private Tecan.Sila2.IntegerDto _timeout;
        
        /// <summary>
        /// Initializes a new instance (to be used by the serializer)
        /// </summary>
        public TimeoutDto()
        {
        }
        
        /// <summary>
        /// Initializes a new data transfer object from the business object
        /// </summary>
        /// <param name="inner">The business object that should be transferred</param>
        /// <param name="store">A component to handle binary data</param>
        public TimeoutDto(Timeout inner, Tecan.Sila2.IBinaryStore store)
        {
            Timeout = new Tecan.Sila2.IntegerDto(inner.Value, store);
        }
        
        /// <summary>
        /// The timeout in seconds
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.IntegerDto Timeout
        {
            get
            {
                return _timeout;
            }
            set
            {
                _timeout = value;
            }
        }
        
        /// <summary>
        /// Extracts the transferred value
        /// </summary>
        /// <param name="store">The binary store in which to store binary data</param>
        /// <returns>the inner value</returns>
        public Timeout Extract(Tecan.Sila2.IBinaryStore store)
        {
            return new Timeout(Timeout.Extract(store));
        }
        
        /// <summary>
        /// Creates the data transfer object from the given object to transport
        /// </summary>
        /// <param name="inner">The object to transfer</param>
        /// <param name="store">An object to store binary data</param>
        public static TimeoutDto Create(Timeout inner, Tecan.Sila2.IBinaryStore store)
        {
            return new TimeoutDto(inner, store);
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            string errors = ("" + Argument.Require(Timeout, "timeout"));
            if ((Timeout.Value < 0))
            {
                errors = (errors + string.Format("Timeout should have been at least 0 but was \'{0}\'", Timeout.Value));
            }
            return errors;
        }
    }
}
